;;; Discussion 13 - Review Potpourri and SQL ;;;

; Q2.1 - skip-list
;;; Tests
; (skip-list '(1 (3)) even?)
; expect ()
; (skip-list '(1 (2 (3 4) 5) 6 (7) 8 9) odd?)
; expect (1 3 5 7 9)

(define (skip-list lst filter-fn)
  (define (helper lst lst-so-far next)
    (cond
      ((null? lst) (if (null? next)
        lst-so-far
        (helper (car next) lst-so-far (cdr next)))
      )
      ((pair? (car lst))
        (helper (car lst)
          lst-so-far
          (cons (cdr lst) next)))
      ((filter-fn (car lst))
        (helper (cdr lst) (append lst-so-far (list (
          car lst))) next))
      (else (helper (cdr lst) lst-so-far next))
    )
  )
  (helper lst nil nil)
)